﻿------------------------------------------------------------------------------------------
--Death Knight Runes----------------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, M, _ = unpack(select(2,...))
local LSM = LibStub("LibSharedMedia-3.0")
local CP = SN:GetModule("classResources")

local runemap = { 1, 2, 5, 6, 3, 4 }
local GetRuneCooldown = GetRuneCooldown
local GetSpecialization = GetSpecialization
local GetRuneType = GetRuneType
local GetTime = GetTime
local IsAddOnLoaded = IsAddOnLoaded
local collectgarbage = collectgarbage
local unpack = unpack

function CP:SetupRunes()
	if SN.playerClass ~= "DEATHKNIGHT" then return end
	local frame = F.classpower
	local color = M.classResources.DEATHKNIGHT
	local maxRune = SN['classMaxResourceBar']["DEATHKNIGHT"]

	frame.runes = CP:PowerBubbles(maxRune)
	frame.runes.maxRune = maxRune

	frame.runes:SetScript('OnUpdate', function(self, elapsed)
		if GetSpecialization() == nil and elapsed then return end
		local runes = self:GetParent()
		if(runes) then
			for i=1, self.maxRune do
				CP:UpdateType(self, nil, i)
			end
		end
		self:SetScript('OnUpdate', nil)
	end)
	frame.runes:SetScript("OnEvent", function(self, event, ...)
		if event == "RUNE_POWER_UPDATE" then
			local rid = ...
			CP:UpdateRune(self, event, rid, true)
		elseif event == "RUNE_TYPE_UPDATE" then
			local rid = ...
			CP:UpdateType(self, event, rid, true)
		end
	end)
	frame.runes:Hide()
end

function CP:UpdateType(self, event, rid)
	local runeColors = M.classResources.DEATHKNIGHT
	local rune = self[runemap[rid]]
	if not GetRuneType(rid) and not alt then return; end
	local colors = runeColors[GetRuneType(rid) or alt]
	--local r, g, b = colors[1], colors[2], colors[3]

	rune:SetStatusBarColor(unpack(colors))
end

function Update(self, event)
	for i=1, self.maxRune do
		CP:UpdateRune(self, event, i)
	end
end

function UpdateAllRuneTypes(self, elapsed)
	if GetSpecialization() == nil and elapsed then return end
	local runes = self:GetParent()
	if(runes) then
		for i=1, self.maxRune do
			CP:UpdateType(runes, nil, i)
		end
	end
	self:SetScript('OnUpdate', nil)
end

function CP:UpdateRune(self, event, rid)
	local rune = self[runemap[rid]]
	if(rune) then
		local start, duration, runeReady = GetRuneCooldown(rid)
		if (runeReady) then
			rune:SetMinMaxValues(0, 1)
			rune:SetValue(1)
			rune:SetAlpha(1)
			rune:SetScript("OnUpdate", nil)
		else
			rune.duration = GetTime() - start
			rune.max = duration
			rune:SetMinMaxValues(1, duration)
			rune:SetAlpha(0.45)
			rune:SetScript("OnUpdate", function(self, elapsed)
				local duration = self.duration + elapsed
				if(duration >= self.max) then
					return self:SetScript("OnUpdate", nil)
				else
					self.duration = duration
					return self:SetValue(duration)
				end
			end)
		end
	end
end

function CP:RuneEnable()
	local frame = F.classpower
	frame.runes:Show()
	frame.runes:RegisterEvent("RUNE_TYPE_UPDATE")
	frame.runes:RegisterEvent("RUNE_POWER_UPDATE")
	RuneFrame:Hide()
	RuneFrame:UnregisterAllEvents()
	collectgarbage("collect")
end

function CP:RuneDisable()
	local frame = F.classpower
	frame.runes:UnregisterAllEvents()
	frame.runes:Hide()
	RuneFrame:Show()
	RuneFrame:GetScript("OnLoad")(RuneFrame)
	for i=1,SN['classMaxResourceBar']["DEATHKNIGHT"] do
		local runeButton = _G["RuneButtonIndividual"..i];
		if runeButton then
			RuneButton_Update(runeButton, i, true);
		end
	end
	collectgarbage("collect")
end